function _arrayLikeToArray(r, a) {
  (null == a || a > r.length) && (a = r.length);
  for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
  return n;
}
function _arrayWithHoles(r) {
  if (Array.isArray(r)) return r;
}
function _classCallCheck(a, n) {
  if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function");
}
function _construct(t, e, r) {
  if (_isNativeReflectConstruct()) return Reflect.construct.apply(null, arguments);
  var o = [null];
  o.push.apply(o, e);
  var p = new (t.bind.apply(t, o))();
  return p;
}
function _defineProperties(e, r) {
  for (var t = 0; t < r.length; t++) {
    var o = r[t];
    o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o);
  }
}
function _createClass(e, r, t) {
  return r && _defineProperties(e.prototype, r), Object.defineProperty(e, "prototype", {
    writable: !1
  }), e;
}
function _isNativeReflectConstruct() {
  try {
    var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
  } catch (t) {}
  return (_isNativeReflectConstruct = function () {
    return !!t;
  })();
}
function _iterableToArrayLimit(r, l) {
  var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
  if (null != t) {
    var e,
      n,
      i,
      u,
      a = [],
      f = !0,
      o = !1;
    try {
      if (i = (t = t.call(r)).next, 0 === l) ; else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0);
    } catch (r) {
      o = !0, n = r;
    } finally {
      try {
        if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return;
      } finally {
        if (o) throw n;
      }
    }
    return a;
  }
}
function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(r, e) {
  return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest();
}
function _toPrimitive(t, r) {
  if ("object" != typeof t || !t) return t;
  var e = t[Symbol.toPrimitive];
  if (void 0 !== e) {
    var i = e.call(t, r);
    if ("object" != typeof i) return i;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (String )(t);
}
function _toPropertyKey(t) {
  var i = _toPrimitive(t, "string");
  return "symbol" == typeof i ? i : i + "";
}
function _unsupportedIterableToArray(r, a) {
  if (r) {
    if ("string" == typeof r) return _arrayLikeToArray(r, a);
    var t = {}.toString.call(r).slice(8, -1);
    return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
  }
}

/**
 * singleton constructor(design patterns)
 * @returns {function(*=)}
 * @constructor
 */
var CreateInstance = () => {
  var instance;
  return newInstance => {
    if (newInstance) {
      instance = newInstance;
    }
    return instance;
  };
};

/**
 * determine a string type
 * @param str
 * @returns {boolean}
 */
var isString = str => typeof str === 'string' && str.constructor === String;

/**
 * determine a promise type
 * @param promise
 * @returns {boolean}
 */
var isPromise = promise => Object.prototype.toString.call(promise).slice(8, -1) === 'Promise';

/**
 * function to promise
 * @param normalFunction
 * @param timeout
 * @returns {Promise<any>}
 */
var functionToPromise = (function (normalFunction) {
  var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  if (isPromise(normalFunction)) {
    return normalFunction;
  }

  // eslint-disable-next-line no-undef
  return new Promise(resolve => {
    normalFunction();
    setTimeout(resolve, timeout);
  });
});

/**
 * isLegalConfigKey
 * @param key
 * @returns {boolean}
 */
var isLegalConfigKey = function isLegalConfigKey(key) {
  var configKeys = ['audioSrc', 'position', 'buttonSize', 'iconSize', 'playIcon', 'pauseIcon', 'autoPlay'];
  for (var i = 0; i < configKeys.length; i += 1) {
    if (key === configKeys[i]) {
      return true;
    }
  }
  return false;
};

/**
 * audioButton Need Change
 * @param config
 * @param audioButtonConfig
 * @returns {boolean}
 */
var audioButtonNeedChange = function audioButtonNeedChange(_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
    config = _ref2[0],
    audioButtonConfig = _ref2[1];
  var configKeys = ['position', 'buttonSize', 'iconSize', 'playIcon', 'pauseIcon'];
  for (var i = 0; i < configKeys.length; i += 1) {
    if (config[configKeys[i]] !== audioButtonConfig[configKeys[i]]) {
      return true;
    }
  }
  return false;
};

/**
 * isAudioPlaying
 * @param audio
 */
var isAudioPlaying = audio => !audio.paused;

var _default$2 = /*#__PURE__*/function () {
  /**
   * Audio
   * @param audioSrc
   */
  function _default(_ref) {
    var audioSrc = _ref.audioSrc;
    _classCallCheck(this, _default);
    this.config = {
      audioSrc: audioSrc
    };
    this.audio = new Audio();
    this._init();
  }

  /**
   * getAudioButton
   * @returns {HTMLAudioElement}
   */
  return _createClass(_default, [{
    key: "getAudio",
    value: function getAudio() {
      return this.audio;
    }

    /**
     * play
     * @returns {HTMLAudioElement}
     */
  }, {
    key: "play",
    value: function play() {
      var _this = this;
      var wxFakePlay = function wxFakePlay() {
        return window.WeixinJSBridge.invoke('getNetworkType', {}, function () {
          return _this.audio.play();
        }, false);
      };
      if (window.WeixinJSBridge) {
        wxFakePlay();
      } else {
        document.addEventListener('WeixinJSBridgeReady', function () {
          return _this.audio.play();
        }, false);
      }
      this.audio.play();
      return this.audio;
    }

    /**
     * pause
     * @returns {HTMLAudioElement}
     */
  }, {
    key: "pause",
    value: function pause() {
      this.audio.pause();
      return this.audio;
    }

    /**
     * stop
     * @returns {HTMLAudioElement}
     */
  }, {
    key: "stop",
    value: function stop() {
      this.audio.currentTime = 0;
      this.audio.pause();
      return this.audio;
    }

    /**
     * isPlaying
     * @returns {boolean}
     */
  }, {
    key: "isPlaying",
    value: function isPlaying() {
      return isAudioPlaying(this.audio);
    }

    /**
     * canplay
     * @returns {Promise<>}
     */
  }, {
    key: "canplay",
    value: function canplay() {
      var _this2 = this;
      return new Promise(function (resolve) {
        _this2.audio.addEventListener('canplay', resolve);
      });
    }

    /**
     * init
     * @private
     */
  }, {
    key: "_init",
    value: function _init() {
      this.audio.src = this.config.audioSrc;
      this.audio.preload = 'auto';
      this.audio.loop = true;
    }
  }]);
}();

function styleInject(css, ref) {
  if (ref === void 0) ref = {};
  var insertAt = ref.insertAt;
  if (typeof document === 'undefined') {
    return;
  }
  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';
  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }
  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".YY7FU9uLKr{-ms-flex-pack:center;-ms-flex-align:center;-webkit-tap-highlight-color:rgba(255,0,0,0);-webkit-align-items:center;align-items:center;border:none;cursor:pointer;display:-webkit-flex;display:-ms-flexbox;display:flex;height:15vw;-webkit-justify-content:center;justify-content:center;max-height:60px;max-width:60px;outline:none;position:fixed;-ms-touch-action:manipulation;touch-action:manipulation;width:15vw;z-index:999}.YY7FU9uLKr.left-top{left:0;top:0}.YY7FU9uLKr.top-right{right:0;top:0}.YY7FU9uLKr.right-bottom{bottom:0;right:0}.YY7FU9uLKr.left-bottom{bottom:0;left:0}@-webkit-keyframes iG5H0Uhu8Z{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}to{-webkit-transform:rotate(-1turn);transform:rotate(-1turn)}}@keyframes iG5H0Uhu8Z{0%{-webkit-transform:rotate(0deg);transform:rotate(0deg)}to{-webkit-transform:rotate(-1turn);transform:rotate(-1turn)}}.J57gYboR-w,.PDTV9-opA4{display:block;height:60%;width:60%}.J57gYboR-w{-webkit-animation:iG5H0Uhu8Z 2s linear infinite;animation:iG5H0Uhu8Z 2s linear infinite;background:url(\"data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 64 64'%3E%3Cstyle%3E.st1{fill-rule:evenodd;clip-rule:evenodd;fill:%23fff}%3C/style%3E%3Cpath d='M32 2.8C15.9 2.8 2.8 15.9 2.8 32S15.9 61.2 32 61.2 61.2 48.1 61.2 32 48.1 2.8 32 2.8z' opacity='.2' fill-rule='evenodd' clip-rule='evenodd'/%3E%3Cpath class='st1' d='M32 0C14.3 0 0 14.3 0 32s14.3 32 32 32 32-14.3 32-32S49.7 0 32 0zm0 61.2C15.9 61.2 2.8 48.1 2.8 32S15.9 2.8 32 2.8 61.2 15.9 61.2 32 48.1 61.2 32 61.2z'/%3E%3Cpath class='st1' d='m30.3 11.2-2.1.6L36.1 39c-5.6-.8-10.5 4-10.1 8.7.1 1.6 1.3 2.9 2 3.5 4 3.4 9.4-.2 11.3-5.7.8-2.3.4-4-.8-8.1l-4.9-16.9c2.5-.8 7.7 1 9.4 3.5 1.1 1.6 1.8 3.9 1.4 5.8-.1.5-.4 2 0 1.7.7-.6.9-1.2 1.3-2.4.3-1.1.4-2.7.3-3.7-1.6-10-12.7-7.1-15.7-14.2z'/%3E%3C/svg%3E\") 0 0 no-repeat;background-size:100% 100%}.PDTV9-opA4{background:url(\"data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 64 64'%3E%3Cpath d='M32 2.8C15.9 2.8 2.8 15.9 2.8 32S15.9 61.2 32 61.2 61.2 48.1 61.2 32 48.1 2.8 32 2.8z' opacity='.2' fill-rule='evenodd' clip-rule='evenodd'/%3E%3Cpath d='M32 0C14.3 0 0 14.3 0 32s14.3 32 32 32 32-14.3 32-32S49.7 0 32 0zM2.8 32C2.8 15.9 15.9 2.8 32 2.8c7.7 0 14.6 3 19.9 7.8L10.6 51.9C5.7 46.6 2.8 39.7 2.8 32zM32 61.2c-7.7 0-14.6-3-19.9-7.8l41.3-41.3c4.8 5.2 7.8 12.2 7.8 19.9 0 16.1-13.1 29.2-29.2 29.2z' fill='%23fff'/%3E%3Cpath d='m30.3 11.2-2.1.6L36.1 39c-5.6-.8-10.5 4-10.1 8.7.1 1.6 1.3 2.9 2 3.5 4 3.4 9.4-.2 11.3-5.7.8-2.3.4-4-.8-8.1l-4.9-16.9c2.5-.8 7.7 1 9.4 3.5 1.1 1.6 1.8 3.9 1.4 5.8-.1.5-.4 2 0 1.7.7-.6.9-1.2 1.3-2.4.3-1.1.4-2.7.3-3.7-1.6-10-12.7-7.1-15.7-14.2z' fill-rule='evenodd' clip-rule='evenodd' fill='%23fff'/%3E%3C/svg%3E\") 0 0 no-repeat;background-size:100% 100%}";
var _style = {"musicControlWrapper":"YY7FU9uLKr","pauseIcon":"PDTV9-opA4","playIcon":"J57gYboR-w","reverseRotateZ":"iG5H0Uhu8Z"};
styleInject(css_248z);

/**
 * fragmentIcon
 * @param iconUrl
 * @param className
 * @param size
 * @returns {HTMLSpanElement}
 */
var eIcon = function eIcon(_ref) {
  var iconUrl = _ref.iconUrl,
    className = _ref.className,
    size = _ref.size;
  var icon = document.createElement('span');
  var cssText = '';
  icon.classList.add(className);
  if (iconUrl) {
    cssText += "background-image: url(".concat(iconUrl, "); ");
  }
  if (size) {
    cssText += "width: ".concat(size, "; height: ").concat(size);
  }
  icon.style.cssText = cssText;
  return icon;
};

/**
 * playIcon
 * @param iconUrl
 * @param size
 * @returns {HTMLSpanElement}
 */
var ePlayIcon = function ePlayIcon(_ref2) {
  var iconUrl = _ref2.iconUrl,
    _ref2$size = _ref2.size,
    size = _ref2$size === void 0 ? '' : _ref2$size;
  return eIcon({
    iconUrl: iconUrl,
    className: _style.playIcon,
    size: size
  });
};

/**
 * pauseIcon
 * @param iconUrl
 * @param size
 * @returns {HTMLSpanElement}
 */
var ePauseIcon = function ePauseIcon(_ref3) {
  var iconUrl = _ref3.iconUrl,
    _ref3$size = _ref3.size,
    size = _ref3$size === void 0 ? '' : _ref3$size;
  return eIcon({
    iconUrl: iconUrl,
    className: _style.pauseIcon,
    size: size
  });
};

var _default$1 = /*#__PURE__*/function () {
  /**
   * AudioButton
   * @param buttonSize
   * @param position
   * @param positionType 'fixed'|'absolute'|'relative'|'sticky'|'static' default: 'fixed'
   * @param iconSize
   * @param playIcon
   * @param pauseIcon
   */
  function _default(_ref) {
    var _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'top-right' : _ref$position,
      _ref$positionType = _ref.positionType,
      positionType = _ref$positionType === void 0 ? 'fixed' : _ref$positionType,
      _ref$buttonSize = _ref.buttonSize,
      buttonSize = _ref$buttonSize === void 0 ? '' : _ref$buttonSize,
      _ref$iconSize = _ref.iconSize,
      iconSize = _ref$iconSize === void 0 ? '' : _ref$iconSize,
      _ref$playIcon = _ref.playIcon,
      playIcon = _ref$playIcon === void 0 ? '' : _ref$playIcon,
      _ref$pauseIcon = _ref.pauseIcon,
      pauseIcon = _ref$pauseIcon === void 0 ? '' : _ref$pauseIcon;
    _classCallCheck(this, _default);
    this.config = {
      buttonSize: buttonSize,
      position: position,
      positionType: positionType,
      iconSize: iconSize,
      playIcon: playIcon,
      pauseIcon: pauseIcon
    };
    this.buttonSize = isString(this.config.buttonSize) ? this.config.buttonSize : "".concat(this.config.buttonSize, "px");
    this.iconSize = isString(this.config.iconSize) ? this.config.iconSize : "".concat(this.config.iconSize, "px");
    this.audioButton = document.createElement('a');
    this.playIcon = ePlayIcon({
      iconUrl: this.config.playIcon,
      size: this.iconSize
    });
    this.pauseIcon = ePauseIcon({
      iconUrl: this.config.pauseIcon,
      size: this.iconSize
    });
    this._init();
  }

  /**
   * getAudioButton
   * @returns {
   * HTMLAnchorElement |
   *   {
   *      changeUIToPlay(): void,
   *      _init(): void,
   *      getAudioButton(): *,
   *      changeUIToPause(): void
   *   }
   * }
   */
  return _createClass(_default, [{
    key: "getAudioButton",
    value: function getAudioButton() {
      return this.audioButton;
    }

    /**
     * changeUIToPlay
     */
  }, {
    key: "changeUIToPlay",
    value: function changeUIToPlay() {
      if (this.audioButton.contains(this.pauseIcon)) {
        this.audioButton.removeChild(this.pauseIcon);
      }
      this.audioButton.appendChild(this.playIcon);
    }

    /**
     * changeUIToPause
     */
  }, {
    key: "changeUIToPause",
    value: function changeUIToPause() {
      if (this.audioButton.contains(this.playIcon)) {
        this.audioButton.removeChild(this.playIcon);
      }
      this.audioButton.appendChild(this.pauseIcon);
    }

    /**
     * init
     * @private
     */
  }, {
    key: "_init",
    value: function _init() {
      this.audioButton.classList.add(_style.musicControlWrapper, this.config.position);

      // Init Button Size
      if (!this.buttonSize) {
        var shortW = window.innerWidth > window.innerHeight ? window.innerHeight : window.innerWidth;
        this.buttonSize = "".concat(shortW * 0.15, "px");
      }
      this.audioButton.style.cssText += "width: ".concat(this.buttonSize, "; height: ").concat(this.buttonSize);
      this._setPositionType();
      this.changeUIToPlay();
    }

    /**
     * _setPositionType
     * @private
     */
  }, {
    key: "_setPositionType",
    value: function _setPositionType() {
      // eslint-disable-next-line default-case
      switch (this.config.positionType) {
        // 'fixed' is default in style
        case 'static':
        case 'relative':
        case 'absolute':
        case 'sticky':
          this.audioButton.style.position = this.config.positionType;
      }
    }
  }]);
}();

/**
 * H5AudioControls
 *
 * Function:
 * load
 * play
 * pause
 * stop
 * changeButtonUI
 * isPlaying
 */
var _default = /*#__PURE__*/function () {
  /**
   * H5AudioControls
   * @param audioSrc
   * @param context default: body
   * @param position 'left-top'|'top-right'(default)|'right-bottom'|'left-bottom'
   * @param positionType 'fixed'|'absolute'|'relative'|'sticky'|'static' default: 'fixed'
   * @param buttonSize
   * @param iconSize
   * @param playIcon
   * @param pauseIcon
   * @param autoPlay default: true
   */
  function _default(audioSrc) {
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref$context = _ref.context,
      context = _ref$context === void 0 ? document.body : _ref$context,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? 'top-right' : _ref$position,
      _ref$positionType = _ref.positionType,
      positionType = _ref$positionType === void 0 ? 'fixed' : _ref$positionType,
      _ref$buttonSize = _ref.buttonSize,
      buttonSize = _ref$buttonSize === void 0 ? '' : _ref$buttonSize,
      _ref$iconSize = _ref.iconSize,
      iconSize = _ref$iconSize === void 0 ? '' : _ref$iconSize,
      _ref$playIcon = _ref.playIcon,
      playIcon = _ref$playIcon === void 0 ? '' : _ref$playIcon,
      _ref$pauseIcon = _ref.pauseIcon,
      pauseIcon = _ref$pauseIcon === void 0 ? '' : _ref$pauseIcon,
      _ref$autoPlay = _ref.autoPlay,
      autoPlay = _ref$autoPlay === void 0 ? true : _ref$autoPlay;
    _classCallCheck(this, _default);
    this.config = {
      audioSrc: audioSrc,
      position: position,
      positionType: positionType,
      buttonSize: buttonSize,
      iconSize: iconSize,
      playIcon: playIcon,
      pauseIcon: pauseIcon,
      autoPlay: autoPlay
    };
    this.state = {
      isAudioButtonChanging: false
    };
    this.setContext(context);
    this._init();
  }

  /**
   * setContext
   * @param context
   */
  return _createClass(_default, [{
    key: "setContext",
    value: function setContext(context) {
      this.context = isString(context) ? document.querySelector(context) : context;
      return this;
    }

    /**
     * Load
     * @returns {Promise<void>}
     */
  }, {
    key: "load",
    value: function load() {
      var _this = this;
      return this.appendAudioButton().then(function () {
        return functionToPromise(function () {
          if (_this.config.autoPlay) {
            _this.play();
            _this.audioInstance.canplay().then(function () {
              _this.changeButtonUI();
            });
          }
        });
      });
    }

    /**
     * play
     */
  }, {
    key: "play",
    value: function play() {
      var _this2 = this;
      this.audioInstance.play();
      setTimeout(function () {
        return _this2.changeButtonUI();
      }, 0);
    }

    /**
     * pause
     */
  }, {
    key: "pause",
    value: function pause() {
      var _this3 = this;
      this.audioInstance.pause();
      setTimeout(function () {
        return _this3.changeButtonUI();
      }, 0);
    }

    /**
     * stop
     */
  }, {
    key: "stop",
    value: function stop() {
      var _this4 = this;
      this.audioInstance.stop();
      setTimeout(function () {
        return _this4.changeButtonUI();
      }, 0);
    }

    /**
     * changeButtonUI
     */
  }, {
    key: "changeButtonUI",
    value: function changeButtonUI() {
      if (this.isPlaying()) {
        this.audioButtonInstance.changeUIToPlay();
      } else {
        this.audioButtonInstance.changeUIToPause();
      }
    }

    /**
     * dynamically change the value of configuration properties
     * @param key
     * @param val
     * @returns {Promise<void>}
     */
  }, {
    key: "change",
    value: function change(key, val) {
      var _this5 = this;
      if (!isLegalConfigKey(key)) {
        return Promise.resolve();
      }
      if (typeof val === 'undefined') {
        return Promise.resolve();
      }
      this.config[key] = val;
      if (key === 'autoPlay') {
        return Promise.resolve();
      }
      if (key === 'audioSrc') {
        return Promise.resolve().then(function () {
          return functionToPromise(function () {
            _this5.stop();
            _this5._initAudioInstance();
          });
        }).then(function () {
          return functionToPromise(function () {
            if (_this5.config.autoPlay) {
              _this5.play();
            }
          });
        });
      }
      if (this.state.isAudioButtonChanging) {
        return Promise.resolve().then(function () {
          return functionToPromise(function () {}, 10);
        }).then(function () {
          return _this5.change(key, val);
        });
      }
      this.state.isAudioButtonChanging = true;
      return Promise.resolve().then(function () {
        if (!audioButtonNeedChange([_this5.config, _this5.audioButtonInstance.config])) {
          _this5.state.isAudioButtonChanging = false;
          return Promise.resolve();
        }
        return Promise.resolve().then(function () {
          return _this5.repaintAudioButton();
        }).then(function () {
          return functionToPromise(function () {
            _this5.state.isAudioButtonChanging = false;
          });
        });
      });
    }

    /**
     * changeAudioSrc
     * @param src
     * @returns {Promise<void>}
     */
  }, {
    key: "changeAudioSrc",
    value: function changeAudioSrc(src) {
      return this.change('audioSrc', src);
    }

    /**
     * changePosition
     * @param position
     * @returns {Promise<void>}
     */
  }, {
    key: "changePosition",
    value: function changePosition(position) {
      return this.change('position', position);
    }

    /**
     * changeButtonSize
     * @param size
     * @returns {Promise<void>}
     */
  }, {
    key: "changeButtonSize",
    value: function changeButtonSize(size) {
      return this.change('buttonSize', size);
    }

    /**
     * changeIconSize
     * @param size
     * @returns {Promise<void>}
     */
  }, {
    key: "changeIconSize",
    value: function changeIconSize(size) {
      return this.change('iconSize', size);
    }

    /**
     * isPlaying
     * @returns {boolean}
     */
  }, {
    key: "isPlaying",
    value: function isPlaying() {
      return this.audioInstance.isPlaying();
    }

    /**
     * eventBind
     */
  }, {
    key: "eventBind",
    value: function eventBind() {
      var _this6 = this;
      this.audioButtonInstance.getAudioButton().addEventListener('click', function (e) {
        e.stopPropagation();
        if (_this6.isPlaying()) {
          _this6.pause();
          return;
        }
        _this6.play();
      });
      return this;
    }

    /**
     * Repaint AudioButton
     * @returns {Promise<void>}
     */
  }, {
    key: "repaintAudioButton",
    value: function repaintAudioButton() {
      var _this7 = this;
      return Promise.resolve().then(function () {
        return functionToPromise(function () {
          _this7.context.removeChild(_this7.audioButtonInstance.getAudioButton());
        });
      }).then(function () {
        return functionToPromise(function () {
          _this7._initAudioButtonInstance();
        });
      }).then(function () {
        return _this7.appendAudioButton();
      });
    }

    /**
     * appendAudioButton
     * @returns {Promise<void>}
     */
  }, {
    key: "appendAudioButton",
    value: function appendAudioButton() {
      var _this8 = this;
      return Promise.resolve().then(function () {
        return functionToPromise(function () {
          _this8.context.appendChild(_this8.audioButtonInstance.getAudioButton());
          _this8.changeButtonUI();
          _this8.eventBind();
        });
      });
    }

    /**
     * Init
     * @private
     */
  }, {
    key: "_init",
    value: function _init() {
      this._initAudioInstance();
      this._initAudioButtonInstance();
    }

    /**
     * InitAudioInstance
     * @private
     */
  }, {
    key: "_initAudioInstance",
    value: function _initAudioInstance() {
      this.audioInstance = new _default$2({
        audioSrc: this.config.audioSrc
      });
      return this;
    }

    /**
     * InitAudioButtonInstance
     * @private
     */
  }, {
    key: "_initAudioButtonInstance",
    value: function _initAudioButtonInstance() {
      this.audioButtonInstance = new _default$1({
        buttonSize: this.config.buttonSize,
        position: this.config.position,
        positionType: this.config.positionType,
        iconSize: this.config.iconSize,
        playIcon: this.config.playIcon,
        pauseIcon: this.config.pauseIcon
      });
      return this;
    }
  }]);
}();

var instance = CreateInstance();

/**
 * h5AudioControls
 * @param param
 * @returns {H5AudioControls}
 */
var index = (function () {
  if (instance()) {
    return instance();
  }
  for (var _len = arguments.length, param = new Array(_len), _key = 0; _key < _len; _key++) {
    param[_key] = arguments[_key];
  }
  var h5AudioControls = _construct(_default, param);
  instance(h5AudioControls);
  return h5AudioControls;
});

export { index as default };
